//
// NOTE:	This code mainly from Dr. Shaffer's book
// A simple implementation of a list class
//
const int LIST_SIZE = 10;
template <class ELEM>
class link
{
public:
	ELEM element;

	link *next;
	
	link(const ELEM& elemval, link<ELEM>* nextval = NULL)
	
	{ element = elemval; next = nextval; }
	
	link(link<ELEM>* nextval = NULL) { next = nextval; }
	
	~link() { }
};

template <class ELEM>
class list
{
	link<ELEM>* head;
	link<ELEM>* tail;
	link<ELEM>* curr;
public:
	list() { tail = head = curr = new link<ELEM>; }

	~list()
	{
		while(head != NULL) { curr = head; head = head->next; delete curr; }
	}

	void clear()
	{
		while (head->next != NULL)
		{
			curr = head->next;
			head->next = curr->next;
			delete curr;
		}
		curr = tail = head;
	}

	bool insert(const ELEM& item)
	{
		assert(curr != NULL);
		curr->next = new link<ELEM>(item, curr->next);
		if (tail == curr) tail = curr->next;
		return true;
	}

	void append(const ELEM& item)
	{ tail = tail->next = new link<ELEM>(item, NULL); }

	ELEM remove()
	{
		assert(isInList());
		ELEM temp = curr->next->element;
		link<ELEM>* ltemp = curr->next;
		curr->next = ltemp->next;
		if (tail == ltemp) tail = curr;
		delete ltemp;
		return temp;
	}

	ELEM currValue() const
	{
		if (isInList())
			return curr->next->element;
		else
			return NULL;
	}

	void setFirst() { curr = head; }

	void next() { if (curr != NULL) curr = curr->next; }

	int length() const
	{
		int temp = 0;
		link<ELEM>* ltemp = head;
		while (ltemp != tail)
		{
			temp++;
			ltemp = ltemp->next;
		}
		return temp;
	}

	bool isEmpty() const { return (head == tail); }

	bool isInList() const { return (curr != NULL) && (curr->next != NULL); }

	void setPos(const int pos)
	{
		curr = head;
		for(int i = 0; (curr != NULL) && (i < pos); i++)
			curr = curr->next;
	}
};