/***********************************************************
 * control.h -- definitions of Swan state variables        *
 * Jun Yang, Nov. 17, 1994				   *
 ***********************************************************/

/*--------------- Global Variables Declarations ---------------*/

extern FLAG fSwanInited ; 
extern FLAG fSwanWinInited ;

extern int fProgState ;
extern int fNextStep ;

extern bool fWaitRun ;
extern bool fWaitStep ;
extern bool fWaitQuit ;
extern bool fWaitInsNode ;
extern bool fWaitDelNode ;
extern bool fWaitInsEdge ;
extern bool fWaitDelEdge ;
extern bool fWaitGraphPicked ;
extern bool fWaitNodePicked ;
extern bool fWaitEdgePicked ;
extern bool fWaitPosPicked ;
extern bool fWaitStrInput ;  
extern bool fWaitNodeChangeAttr ;
extern bool fWaitEdgeChangeAttr ;
extern bool fWaitGraphChangeAttr ;

extern bool fNewLayout ;

// internal variables to control the modifications of graphical
// attributes of a graph
extern COLORTYPE _gm_nodecolor ;
extern NODETYPE  _gm_nodetype ;
extern FLAG	 _gm_nodefill ;
extern int	 _gm_nodewidth ;
extern int	 _gm_nodeheight ;
extern int	 _gm_nodelineth ;
extern int	 _gm_edgelength ;
extern int	 _gm_edgelineth ;
extern COLORTYPE _gm_edgecolor ;

// internal variables to control the modications of graphical 
// attributes of a single node  
extern COLORTYPE _nm_nodecolor ;
extern NODETYPE  _nm_nodetype ;
extern FLAG	 _nm_nodefill ;
extern int	 _nm_nodewidth ;
extern int	 _nm_nodeheight ;
extern int	 _nm_nodelineth ;


// internal variables to control the modications of graphical 
// attributes of a single edge  
extern COLORTYPE _em_egdecolor ;
extern int	 _em_edgelength ;
extern int	 _em_edgelineth ;

/*--------------- function prototypes ---------------*/

extern int showrunframe(bool) ;
extern int showstepframe(bool) ;

/***********************************************************
 * End of control.h 				           *
 ***********************************************************/
