#ifndef _STACK_HPP
#define _STACK_HPP


template<class T>
class Stack
{

  protected:
    // nested structure
    struct StackNode {
        T nodeData;
        StackNode *nextPtr;
    };

    unsigned height;   // height of stack
    bool allocateError; // dynamic allocation error
    StackNode *top; // pointer to the top of the stack
    Stack<T>& copy(Stack<T>&);

  public:
    Stack();
    ~Stack()
      { clear(); }
    /* ****************** state query methods ***************** */
    bool isempty() const {
        return (height == 0) ? true : false;
    }
    bool getAllocateError() const
      { return allocateError; }

    /* ************** object manipulation methods ************* */
    void push(T);
    bool pop(T&);
    void clear();
    Stack<T>& operator =(Stack<T>& g)
      { copy(g); return *this; }
};

#endif
