
/**********
 *	Include files
 **********/

#include "sail.h"
#include "tools.h"

/**********
 *	Constant definitions
 **********/

#define INFINITELARGE	10000

/*********
 *	Type definitions
 *********/

typedef int 	NODE_ID ;
typedef int	WEIGHT ;

typedef struct neighbour_node {
	NODE_ID		id ;
	WEIGHT		weight ;
} NEIGHBOUR_NODE ;

typedef struct neighbour_link {
	NEIGHBOUR_NODE		*nb_ptr ;
	struct neighbour_link	*next_nb ;
} NEIGHBOUR_LINK ;	

typedef struct node {
	NODE_ID		id ;
	NODE_ID		in_node ;
	WEIGHT		cost ;
	BOOLEAN		mark ;
	NEIGHBOUR_LINK	*nb_list ;
} NODE ;

typedef struct node_link {
	NODE			*node_ptr ;
	struct node_link	*next_node ;
} NODE_LINK ;

typedef struct edge {
	NODE_ID		node1 ;
	NODE_ID		node2 ;
	WEIGHT		weight ;
} EDGE ;

typedef struct edge_link {
	EDGE			*edge_ptr ;
 	struct edge_link	*next_edge ;
} EDGE_LINK ;	

typedef struct weight_node {
	int		val ;
} WEIGHTNODE ;

void mst(char*, char*) ;
void usage(void) ;
void initialize(void) ;
int get_graph(char*) ;
int get_mgraph(char*) ;
void insert_edge(NODE_ID, NODE_ID, WEIGHT) ;
void insert_nb(NODE*, NODE_ID, WEIGHT) ;
void insert_mst(NODE_ID, NODE_ID, WEIGHT) ;
void output_mst(char*) ;
int error(char*) ;
int _insertnode(void) ;
int _deletenode(void) ;
int _insertedge(void) ;
int _deleteedge(void) ;
void find_min_weight_node(NODE_LINK**) ; 
int create_graph_ll(void) ;
